#include "BluetoothSerial.h"
// COMMANDS BT:
// 0 : LED OFF
// 1 : LED ON
// 3 : CLOSE CURTAIN
// 4 : STOP MOTOR
// 5 : OPEN CURTAIN
BluetoothSerial SerialBT;

const int LED_BUILTIN = 4;
const int LIMIT_SWITCH_CLOSE = 12;
const int LIMIT_SWITCH_OPEN = 13;
const int PIN_MOTOR_AIN1 = 14;
const int PIN_MOTOR_AIN2 = 15;
const int STOP = 4;
const int CLOSE = 3;
const int OPEN = 5;
int command = 0;
int ls_close = LOW;
int ls_open = LOW;
bool new_command = false;
// the setup function runs once when you press reset or power the board
void setup() {
  // initialize digital pin LED_BUILTIN as an output.
  SerialBT.begin("ESP32-Bluetooth");
  pinMode(LED_BUILTIN, OUTPUT);
  pinMode(LIMIT_SWITCH_CLOSE, INPUT);
  pinMode(LIMIT_SWITCH_OPEN, INPUT);
  pinMode(PIN_MOTOR_AIN1, OUTPUT);
  pinMode(PIN_MOTOR_AIN2, OUTPUT);      
  Serial.begin(9600);
  Serial.print("BT CURTAIN CONTROLLER v0 ");
}

// the loop function runs over and over again forever
void loop() {
  // FIRST: READ BT 
  if (SerialBT.available()){
    char c = SerialBT.read();
    if(c=='1'){
      digitalWrite(LED_BUILTIN, HIGH);
      Serial.println("BT command LED ON...");
    }else if (c=='0'){
      digitalWrite(LED_BUILTIN, LOW);
      Serial.println("BT command LED OFF...");
    }
    if(c=='3'){
      command = CLOSE;
      new_command = true;
      Serial.println("BT command CLOSE curtain...");
    }
    if(c=='4'){
      command = STOP;
      new_command = true;
      Serial.println("BT command STOP curtain...");
    }
    if(c=='5'){
      command = OPEN;
      new_command = true;
      Serial.println("BT command OPEN curtain...");
    }
  }
// SECOND: READ INPUTS
 ls_close = digitalRead(LIMIT_SWITCH_CLOSE);
 ls_open = digitalRead(LIMIT_SWITCH_OPEN);

 // PROCCES COMMANDS 
 if ((command == CLOSE) && (ls_close == LOW)) {
  if (new_command == true){
    close_Curtain();
    Serial.println("close curtain...");
   }

  }
   if ((command == CLOSE) && (ls_close == HIGH)) {

       stop_Curtain();
       Serial.println("stop curtain...");;
 
   }
 if ((command == OPEN) && (ls_open == LOW)) {
   if (new_command == true){
     open_Curtain();
     Serial.println("open curtain...");
  }
 }
 if ((command == OPEN) && (ls_open == HIGH)) {
 
   stop_Curtain();
   Serial.println("stop curtain...");

 }
   if (command == STOP)  {
     if (new_command == true){
      stop_Curtain();
      Serial.println("stop curtain...");
    }
   }
}

void close_Curtain() {
  digitalWrite(PIN_MOTOR_AIN1, HIGH);
  digitalWrite(PIN_MOTOR_AIN2, LOW);
  new_command = false;
}
void open_Curtain() {
  digitalWrite(PIN_MOTOR_AIN1, LOW);
  digitalWrite(PIN_MOTOR_AIN2, HIGH);
 new_command = false;
}

void stop_Curtain(){
  digitalWrite(PIN_MOTOR_AIN1, LOW);
  digitalWrite(PIN_MOTOR_AIN2, LOW);
 new_command = false;
}
